# PyPI Maker
> Software designed for simplifying PyPI Python package setups

[![Donate](https://img.shields.io/badge/Donate-PayPal-green.svg)](https://www.paypal.com/donate/?business=UA5NL9MJSFMVY)

## Getting Started

### Dependencies

[Python 3](https://www.python.org/downloads/) must be installed before pypimaker can be installed.

### Installation

To install pypimaker, open a terminal window and run the following command:

```
pip install pypimaker
```

*(Note that the* `pip3` *command may be required instead of* `pip` *for some Python installations.)*

## Generating Your PyPI Files

To generate the files needed for your PyPI package, run the following command:

```
pypimaker generate
```

This will launch a graphical user interface that looks like the following:
![](https://github.com/bdavis222/pypimaker/blob/main/images/0.png)

Inputting the information for your project will generate all of the files needed for uploading it to PyPI (`LICENSE`, `README.me`, `requirements.txt`, and `setup.py`). This can be re-run at any time to re-generate these files.

## Reorganizing Files

For those who tend to pile a bunch of Python files into the same directory, a utility is included for helping users reorganize their files. After moving your files into an organized folder structure, run the following command:

```
pypimaker fix
```

**Important: For this to work properly, your folders must not be named the same as any of your files.**

This will fix all of your imports so that they will work with the new structure you've created. If this causes any errors, it can be reverted at any time with the following command:

```
pypimaker unfix
```

## Uploading Your Finished Project to PyPI

If you don't yet have an account on PyPI, [register for one](https://pypi.org/account/register/). Once you've set up your account and you're ready to upload your package to PyPI (e.g., after you have updated the generated template `README.md` file to your liking), run the following command:

```
pypimaker upload
```

You will be asked to enter your PyPI username and password (which you've registered previously) in the terminal. Your project will then be uploaded to PyPI, and others can download it using the following command:

```
pip install <PROJECT_NAME>
```

*(Here, <PROJECT_NAME> is the name you selected when running `generatefiles.py`)*

## Resetting Your Project

At any time, all of the files generated by PyPI Maker can be removed with the following command:

```
pypimaker reset
```

## Making changes to your PyPI project

To make changes and update your project, simply re-run `pypimaker upload`. Follow the steps in the terminal to incremement your version number and your update will be pushed to PyPI.

## Development

### Testing

Tests for this template project use [Python's built-in unittest framework](https://docs.python.org/3/library/unittest.html), and are stored in the `tests` folder. To run tests, navigate to the top level of the project's folder structure and run the following command:

```
python -m unittest
```

### Bug Reports and Feature Requests

To report a bug, visit the [issues page](https://github.com/bdavis222/project_template/issues). New feature requests are also welcome!